



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>asp.net mvc area实现多级controller和多级view</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">asp.net mvc area实现多级controller和多级view</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 10:19:06 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>经常需要描述这样的项目结构</p>
<p>~:.　　　　　　　　//web根目录<br />├─.admin　　　　&nbsp; //管理员功能目录<br />│&nbsp; └─index.html　&nbsp;&nbsp; //管理员目录页面<br />├─.user &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &nbsp; &nbsp; &nbsp; //用户功能目录<br />│&nbsp; └─index.html&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; //用户功能目录<br />└─index.html&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; //首页</p>
<p>在普通的mvc之下，我们需要将每个controller和view都写在固定的页面中，这样所有的文件都堆砌在这两个目录中，</p>
<p>对于普通的小型项目，这样或许是比较方便的解决方案，但需要将项目目录进行细致的划分的时候默认的mvc目录就</p>
<p>无法实现我们需要的功能了。</p>
<p>一般我们会使用两种方式来实现</p>
<p>1.通过自定义路由+自定义视图引擎</p>
<p>2.使用area来对每个目录进行具体的管理</p>
<p>示例如下：</p>
<p>描述：系统包括三种主要用户类型，学生、教师、管理员，对于每种用户的相关功能代码分类进行整体，便于集中管理也利于</p>
<p>区分其他功能避免文件较多产生歧义</p>
<p>1.通过自定义路由+自定义视图引擎</p>
<p>首先定义路由规则，在项目目录下的App_Start/RouteConfig.cs文件中进行配置</p>
<div>
<pre class="prettyprint linenums"> public static void RegisterRoutes(RouteCollection routes)<br />
         {<br />
             routes.IgnoreRoute("{resource}.axd/{*pathInfo}");

             //添加自定义的路由规则<br />
             routes.MapRoute(<br />
                 //根据约定，需要保证路由名的唯一性<br />
                 name: "teacher",<br />
                 //此处通过添加teacher部分来区分教师的功能页面<br />
                 url: "teacher/{controller}/{action}/{id}",<br />
                 defaults: new { controller = "Home", action = "Index", id = UrlParameter.Optional },<br />
                 //此处由于多个路由规则都使用了名为Home的controller，所以需要<br />
                 //传入名称空间来保证控制器的唯一性<br />
                 namespaces:new string[] { "SCMS.Controllers.teacher" });<br />
             routes.MapRoute(<br />
                 name: "manager",<br />
                 url: "manager/{controller}/{action}/{id}",<br />
                 defaults: new { controller = "Home", action = "Index", id = UrlParameter.Optional },<br />
                 namespaces: new string[] { "SCMS.Controllers.manager" });<br />
             routes.MapRoute(<br />
                 name: "admin",<br />
                 url: "admin/{controller}/{action}/{id}",<br />
                 defaults: new { controller = "Home", action = "Index", id = UrlParameter.Optional },<br />
                 namespaces: new string[] { "SCMS.Controllers.admin" });

             //系统定义的路由规则<br />
             routes.MapRoute(<br />
                 name: "Default",<br />
                 url: "{controller}/{action}/{id}",<br />
                 defaults: new { controller = "Home", action = "Index", id = UrlParameter.Optional },<br />
                 namespaces: new string[] { "SCMS.Controllers" });<br />
         }            </pre>
</div>
<p>重写视图引擎部分</p>
<p>构造如下的一个类,继承RazorViewEngine类，并重写ViewLocationFormats的内容</p>
<div>
<pre class="prettyprint linenums">public class ViewEngine : RazorViewEngine<br />
    {

        public ViewEngine()<br />
        {<br />
            ViewLocationFormats = new[]<br />
            {<br />
                "~/Views/{1}/{0}.cshtml",<br />
                "~/Views/Shared/{0}.cshtml",<br />
                "~/Views/admin/{1}/{0}.cshtml",<br />
                "~/Views/teacher/{1}/{0}.cshtml",<br />
                "~/Views/manager/{1}/{0}.cshtml"<br />
            };<br />
        }

    }</pre>
</div>
<p>清除原有的视图引擎并将重写的视图引擎传入，文件位置为全局Global.asax文件</p>
<div>
<pre class="prettyprint linenums"> protected void Application_Start()<br />
        {<br />
            AreaRegistration.RegisterAllAreas();<br />
            RouteConfig.RegisterRoutes(RouteTable.Routes);<br />
            //注意此处<br />
            ViewEngines.Engines.Clear();<br />
            ViewEngines.Engines.Add(new ViewEngine());<br />
        }</pre>
</div>
<p>根据网上教程经过尝试后发现能够实现自定义目录的目的，但是根据此处的view解析目录，系统默认提供的</p>
<p>解析方式和自定义的解析方式只有一个能保证访问成果，若有使用不当之处望周知。此处给出一个不算恰当</p>
<p>的解决方案，将直接存放在默认位置的首页也独立管理即可。然后去掉"~/Views/{1}/{0}.cshtml"项，加入</p>
<p>"~/Views/Home/{1}/{0}.cshtml"</p>
<p>至此，第一种方式已经结束</p>
<p>2.使用area来对每个目录进行具体的管理</p>
<p>通过第一种办法虽能实现我们需要的功能，但是对于功能较多的项目来说对于每一个功能都需要单独处理，</p>
<p>这样需要重写大量的路由规则和view匹配规则，也可能是对mvc的了解不够所以没发现更好的办法，这里</p>
<p>就可以使用area区域来对其目录结构进行管理，如下</p>
<p>通过右键项目目录新建区域建立区域框架，然后创建了如下的目录结构</p>
<p>C:\USERS\IVES\DESKTOP\SCMS\SCMS\AREAS<br />├─admin<br />│&nbsp; ├─Controllers<br />│&nbsp; ├─Models<br />│&nbsp; └─Views<br />│&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; ├─Home<br />│&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; └─Shared<br />├─manager<br />│&nbsp; ├─Controllers<br />│&nbsp; ├─Models<br />│&nbsp; └─Views<br />│&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; └─Shared<br />└─teacher<br />&nbsp;&nbsp;&nbsp; ├─Controllers<br />&nbsp;&nbsp;&nbsp; ├─Models<br />&nbsp;&nbsp;&nbsp; └─Views<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; └─Shared</p>
<p>此处我们可以发现每个区域的目录结构树中均包含独立的MVC的结构，我们只需要将对应的每一个目录的内容放入对应的区域即可</p>
<p>具体内容见下图</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/944369/201711/944369-20171115145706843-724019391.png" /></p>
<p>如图，我们只需要将原来直接写在项目路径下的相关内容直接写在此处对应area中即可，其他与原来的使用方式没有任何差别</p>
<p>此处的第二种方式既直挂又简单快捷，推荐使用</p>
<p>记录下来，留待后查，同时方便他人。</p>
<p>联系我进行交流。renhanlinbsl@163.com</p>
<p>2017.11.15</p>
<p>15:37</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/39rd6e80.html">Socket聊天程序&mdash;&mdash;客户端</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnp528r.html">Entity Framework 教程&mdash;&mdash;什么是Entity Framework</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7ojk18.html">创建 flat network - 每天5分钟玩转 OpenStack（87）</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zxke1q.html">Ubuntu14&period;04安装MySql</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq42dee9.html">iOS开发&mdash;&mdash;UI基础-UIButton、UIImageView、UILabel的选择</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9p5yo78.html">&excl;&excl; 据说年薪30万的Android程序员必须知道事</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxp5rj9.html">&lbrack;CareerCup&rsqb; 1&period;6 Rotate Image 翻转图像</a>
		</li>
						<li><a href="https://www.batexi.com/a/390o2449.html">QEMU-KVM中的多线程压缩迁移技术</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdd3xr8.html">&lbrack;mondrian&rsqb; 快速入门</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xnjkz9.html">Inversions</a>
		</li>
						<li><a href="https://www.batexi.com/a/96oy6en9.html">将多个&period;a库合并为一个&period;a库的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0dnkwq.html">锋利的JQuery-认识Jquery</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vkxp48.html">MySQL在线备份与恢复工具 --&amp;gt&semi; Xtrabackup</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm2ygx9.html">HDOJ&sol;HDU Tempter of the Bone&lpar;深搜&plus;奇偶性剪枝&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvw0y1q.html">Android四大组件之ContentProvider（二）读取设备上的图片、音频和视频</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yyrpz8.html">COM Interop</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z7n1k9.html">hibernate对象的状态以及生命周期</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj5dm38.html">解释 &colon; translate 功能&comma;过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/93w7en0q.html">【问题解决：SFL4J】启动时SLF4J报错</a>
		</li>
						<li><a href="https://www.batexi.com/a/960lovn9.html">做h5动画会用到的一个很好的缓动算法库</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8o14lwpq.html">Linux下编译安装redis</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r5nmk7q.html">【大数据技术】Flink</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxd2rxj9.html">【APIO2018】铁人两项</a>
			</li>
						<li><a href="https://www.batexi.com/a/qll1do0q.html">虚拟化技术QEMU-KVM入门</a>
			</li>
						<li><a href="https://www.batexi.com/a/93wp2mgq.html">005&lowbar;python对整数的拼接</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdwjyvv9.html">linux7 udev的生效</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1m3gg9.html">upper&lowbar;bound</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2j076q.html">深入理解koa中的co源码</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e4mvpk9.html">layer 查看图片</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zyk01x9.html">Android自定义相机拍照并使用CardView展示</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
